#!/bin/bash

ensure_common_definitions() {
  schema="$1"
  type_enum="$2"

  # shellcheck disable=SC2016
  verify_schema_contains_selector "$schema" '."$id"'
  verify_schema_contains_selector "$schema" ".title"
  verify_schema_contains_selector "$schema" ".description"
  verify_schema_contains_selector "$schema" ".self.version"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.analyzer"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.end_time"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.messages"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.options"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.scanner"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.start_time"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.status"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.type.enum == $type_enum"
  verify_schema_contains_selector "$schema" ".properties.schema"
  verify_schema_contains_selector "$schema" ".properties.version"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.description"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.details"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.id"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.identifiers"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.links"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.name"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.severity"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.solution"

  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.tracking"
  verify_schema_contains_selector "$schema" ".properties.vulnerabilities.items.properties.tracking.properties.type"
  tracking_source_type='.properties.vulnerabilities.items.properties.tracking.oneOf[] | select(.properties.type.const=="source")'
  verify_schema_contains_selector "$schema" "$tracking_source_type.properties.items.items.properties.file"
  verify_schema_contains_selector "$schema" "$tracking_source_type.properties.items.items.properties.start_line"
  verify_schema_contains_selector "$schema" "$tracking_source_type.properties.items.items.properties.end_line"
  verify_schema_contains_selector "$schema" "$tracking_source_type.properties.items.items.properties.signatures"

  verify_schema_contains_selector "$schema" ".definitions.detail_type"
  verify_schema_contains_selector "$schema" ".definitions.text_value"
  verify_schema_contains_selector "$schema" ".definitions.named_field"
  verify_schema_contains_selector "$schema" ".definitions.named_list"
  verify_schema_contains_selector "$schema" ".definitions.list"
  verify_schema_contains_selector "$schema" ".definitions.table"
  verify_schema_contains_selector "$schema" ".definitions.text"
  verify_schema_contains_selector "$schema" ".definitions.url"
  verify_schema_contains_selector "$schema" ".definitions.code"
  verify_schema_contains_selector "$schema" ".definitions.value"
  verify_schema_contains_selector "$schema" ".definitions.diff"
  verify_schema_contains_selector "$schema" ".definitions.markdown"
  verify_schema_contains_selector "$schema" ".definitions.commit"
  verify_schema_contains_selector "$schema" ".definitions.file_location"
  verify_schema_contains_selector "$schema" ".definitions.file_location.properties.column_start"
  verify_schema_contains_selector "$schema" ".definitions.file_location.dependencies.column_start"
  verify_schema_contains_selector "$schema" ".definitions.file_location.properties.column_end"
  verify_schema_contains_selector "$schema" ".definitions.file_location.dependencies.column_end"
  verify_schema_contains_selector "$schema" ".definitions.module_location"
  verify_schema_contains_selector "$schema" ".definitions.code_flow_node"
  verify_schema_contains_selector "$schema" ".definitions.code_flows"
  verify_schema_contains_selector "$schema" ".properties.remediations.items.properties.fixes"
  verify_schema_contains_selector "$schema" ".properties.remediations.items.properties.summary"
  verify_schema_contains_selector "$schema" ".properties.remediations.items.properties.diff"

  verify_schema_contains_selector "$schema" ".properties.scan.properties.observability.properties.events.items.properties.event"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.observability.properties.events.items.properties.property"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.observability.properties.events.items.properties.label"
  verify_schema_contains_selector "$schema" ".properties.scan.properties.observability.properties.events.items.properties.value"
}
